#' e1anilyr_df_data

#' e1anilyr_df_data
#' @param x request object
#' @param res resulted data.frame
#' @keywords e1anilyr_
#' @export
#' @examples
#' \dontrun{
#' e1anilyr_df_data()
#' }
e1anilyr_df_data <- function(x,res){

  if (nrow(res)>0){
    res[,"from"] <- paste0(res[,"from"],rep("Z",nrow(res)))
    tmp <- friendlyts::ts_spread(df=res, col_date=c("from"),
                                   col_key=c("CO_NAME","ID"),col_target="value",
                                   precision=x$timeObj$precision(),tzone=x$timeObj$tzone(),
                                   date_type="%Y-%m-%dT%H:%M:%OSZ")

    df <- friendlyts::check_date(tbl_fts=tmp, fromDate=x$timeObj$fromDateTime(),toDate=x$timeObj$toDateTime(),timeResolution=x$timeObj$timeResolution(), v=x$timeObj$v(), precision=x$timeObj$precision(), tzone=x$timeObj$tzone(),missingValues=NA,date_type="posixlt")
  } else {
    df <- friendlyts::friendlyts(varnames="empty",date_type=c("posixlt"),fromDate=x$timeObj$fromDateTime(),toDate=x$timeObj$toDateTime(),timeResolution=x$timeObj$timeResolution(),v=x$timeObj$v(),precision=x$timeObj$precision(),tzone=x$timeObj$tzone())
  }

  if (x$dateStructObj$COL_DATE) {
     stop("to be done")
  }
  return(df)
}

#' e1anilyr_df_qa

#' e1anilyr_df_qa
#' @param x request object
#' @param res resulted data.frame
#' @keywords e1anilyr_
#' @export
#' @examples
#' \dontrun{
#' e1anilyr_df_qa()
#' }
e1anilyr_df_qa <- function(x,res){

  if (nrow(df)>0){
    res[,"from"] <- paste0(res[,"from"],rep("Z",nrow(res)))
    tmp <- friendlyts::ts_spread(df=res, col_date=c("date"),
                                   col_key=c("CO_NAME","ID"),col_target="validity",
                                   precision=x$timeObj$precision(),tzone=x$timeObj$tzone(),
                                   date_type="%Y-%m-%dT%H:%M:%OSZ")

    df <- friendlyts::check_date(tbl_fts=tmp, fromDate=x$timeObj$fromDateTime(),toDate=x$timeObj$toDateTime(),timeResolution=x$timeObj$timeResolution(), v=x$timeObj$v(), precision=x$timeObj$precision(), tzone=x$timeObj$tzone(),missingValues=NA,date_type="posixlt")

  } else {
    df <- friendlyts::friendlyts(varnames="empty",date_type=c("posixlt"),fromDate=x$timeObj$fromDateTime(),toDate=x$timeObj$toDateTime(),timeResolution=x$timeObj$timeResolution(),v=x$timeObj$v(),precision=x$timeObj$precision(),tzone=x$timeObj$tzone())

  }

  icol <- friendlyts::get_date_col(precision=x$timeObj$precision())
  names(df) <- c(names(df)[icol],paste0("qa_",names(tmp)[-c(icol)]))

  if (x$dateStructObj$COL_DATE) {
     stop("to be done")
  }
  return(df)
}
