#' e1anilyr_get_data

#' e1anilyr_get_data
#' @param x request object
#' @param username username
#' @param password password
#' @keywords e1anilyr_
#' @export
#' @examples
#' \dontrun{
#' e1anilyr_get_data()
#' }
e1anilyr_get_data <- function(x,username=NULL,password=NULL) {

  api <- eea.nilu::api()

  if (!is.null(x$stationObj$locationName)){
    meta <- e1anilyr_get_meta(x=x,username=username,password=password)
    station_id <- meta$StationEoi
  } else if (!is.null(x$stationObj$station_id)) {
    station_id <- x$stationObj$station_id
  }

  from <- timemanip::posixlt2char(x$timeObj$fromDateTime(),ISO8601=TRUE)
  to <- timemanip::posixlt2char(x$timeObj$toDateTime(),ISO8601=TRUE)

  res <- eea.nilu::get_short_e1a_data(eeaObj=api,Pollutant=x$elementObj$element_id,From=from,To=to,Resolution=timeRes2timeReseea(x$timeObj$timeResolution()),StationEoi=unique(station_id))
  return(res)
}

#' e1anilyr_get_meta

#' e1anilyr_get_meta
#' @param x request object
#' @param username username
#' @param password password
#' @keywords e1anilyr_
#' @export
#' @examples
#' \dontrun{
#' e1anilyr_get_meta()
#' }
e1anilyr_get_meta <- function(x,username=NULL,password=NULL) {
  api <- eea.nilu::api()
  res <- eea.nilu::get_short_metadata_data(eeaObj=api,StationEoi=x$stationObj$station_id,west=x$stationObj$west,south=x$stationObj$south,east=x$stationObj$east,north=x$stationObj$north)
  return(res)
}

#' e1anilyr_get_qa

#' e1anilyr_get_qa
#' @param x request object
#' @param username username
#' @param password password
#' @keywords e1anilyr_
#' @export
#' @examples
#' \dontrun{
#' e1anilyr_get_qa()
#' }
e1anilyr_get_qa <- function(x,username=NULL,password=NULL) {
  res <- e1anilyr_get_data(x=x,username=username,password=password)
  return(res)
}
